      PROGRAM USERS
      INCLUDE '($IODEF)'
      INCLUDE '($JPIDEF)'
      INCLUDE '($SSDEF)'
C
C --- ART RAGOSTA'S SUPER USERS PROGRAM ---
C
      CHARACTER *80 IMAGE
      CHARACTER *13 DELTA, Q(4), P(2)
      CHARACTER *10 USER
      CHARACTER *8 LOGTIM, ctime
      CHARACTER *7 TERMINAL
      CHARACTER *1 ESC
      INTEGER TIMEL(2)
      INTEGER *2 ITEM(44)
      INTEGER *4 ITMLST(22), IOSB(2), ITIME(2)
      EQUIVALENCE (ITEM(1),ITMLST(1))
      EXTERNAL CTLY
      INTEGER SYS$GETJPIW
      logical continuous, subproc, detach, batch, full, inter
      DATA ESC/27/
      data continuous/.false./, subproc/.false./,  inter/.true./
      data detach /.false./, batch/.false./, full/.false./
c
      parameter (max_users=100)
      character *12 x_user    (max_users)
      character *7  x_terminal(max_users)
      character *9  x_cpu     (max_users)
      character *5  x_logtim  (max_users)
      character *40 x_image   (max_users)
      integer       ind       (max_users)
C
      DELTA = '0000 00:00:03'
      CALL GETFOR(NQ,Q,NP,P)
      do 1 i = 1, nq
         if (q(I)(1:1) .eq. 'S') then
            subproc = .true.
         else if (q(I)(1:1) .eq. 'D') then
            detach = .true.
         else if (q(i)(1:1) .eq. 'B') then
            batch = .true.
         else if (q(i)(1:1) .eq. 'F') then
            full = .true.
         else if (q(i)(1:1) .eq. 'A') then
            subproc = .true.
            detach = .true.
            batch = .true.
         else if (q(i)(1:1) .eq. 'N') then
            inter = .false.
         else if (q(I)(1:1) .eq. 'C') then
            continuous = .true.
            if (index(q(i),'=') .ne. 0) then
               q(i) = q(i)(index(q(i),'=')+1:)
               CALL RIGHT(Q(I))
               IF (Q(I)(12:12) .EQ. ' ') Q(I)(12:12) = '0'
               DELTA(12:13) = Q(I)(12:13)
            endif
         endif
1     continue
C
C --- ITEM 1, USERNAME
C
      ITEM(1)   = 10
      ITEM(2)   = JPI$_USERNAME
      ITMLST(2) = %LOC(USER)
      ITMLST(3) = %LOC(LUSER)
C
C --- ITEM 2, LOGIN TIME
C
      ITEM(7)   = 8
      ITEM(8)   = JPI$_LOGINTIM
      ITMLST(5) = %LOC(TIMEL)
      ITMLST(6) = 0
C
C --- ITEM 3, CPU TIME
C
      ITEM(13)  = 4
      ITEM(14)  = JPI$_CPUTIM
      ITMLST(8) = %LOC(ITIMEC)
      ITMLST(9) = 0
C
C --- ITEM 4, IMAGE NAME
C
      ITEM(19)  = 80
      ITEM(20)  = JPI$_IMAGNAME
      ITMLST(11)= %LOC(IMAGE)
      ITMLST(12)= %LOC(LIMAGE)
C
C --- ITEM 5, Jobtype
C
      ITEM(25)  = 4
      ITEM(26)  = JPI$_JOBTYPE
      ITMLST(14)= %LOC(JOBTYPE)
      ITMLST(15)= 0
C
C --- ITEM 6, TERMINAL NAME (TO BE ADDED)
C
      ITEM(31)  = 7
      ITEM(32)  = JPI$_TERMINAL
      ITMLST(17)= %LOC(TERMINAL)
      ITMLST(18)= %LOC(LTERM)
C
C --- ITEM 7, MODE
C
      ITEM(37)  = 4
      ITEM(38)  = JPI$_MODE
      ITMLST(20)= %LOC(MODE)
      ITMLST(21)= 0
C
      ITMLST(22)= 0
C
C --- SET UP CONTROL/Y HANDLING
C
      if (continuous) then
         CALL LIB$DISABLE_CTRL ('02100000'X,)
         CALL SYS$ASSIGN ('SYS$INPUT', ICHAN,,)
         ICODE  = IO$_SETMODE .OR. IO$M_CTRLYAST
         CALL SYS$QIO(,%VAL(ICHAN),%VAL(ICODE),,,,CTLY,,,,,)
         CALL SYS$BINTIM (DELTA,ITIME)
         write (6,900) esc, esc
      endif
C
C --- DISPLAY LOOP
C
5     IPID  = -1
      n_users = 0
C
C --- PROCESS LOOP
C
10    IMAGE = ' '
      IF (SYS$GETJPIW(,IPID,,ITMLST,IOSB,,) .EQ. SS$_NOMOREPROC)
     $     GO TO 20
C
      IF (((mode .eq. 2) .and. batch) .or.      
     $    ((mode .eq. 3) .and. inter) .or.
     $    ((mode .eq. 0) .and. (jobtype .eq. 0) .and. detach)) THEN
         WRITE(CTIME,910,err=15) ITIMEC
15       CALL SYS$ASCTIM (LTIMEC,LOGTIM,TIMEL,%VAL(1))
         IF (JOBTYPE .EQ. 0) THEN
            IF ((.NOT. DETACH) .and. (mode .ne. 3)) GO TO 10
            if (mode .ne. 3) terminal = '-D-'
            if (user .eq. '<login>') go to 10
         ELSE IF (JOBTYPE .EQ. 2) THEN
            IF (.NOT. BATCH) GO TO 10
            TERMINAL = '-B-'
         ELSE IF ((mode .eq. 3) .and. (TERMINAL(1:1) .EQ. CHAR(0))) THEN
            if (.not. subproc) go to 10
            TERMINAL = '-S-'
         ENDIF
         n_users = n_users + 1
         x_user(n_users)     = user
         x_terminal(n_users) = terminal(1:lterm)
         x_cpu(n_users)      = ctime(1:6) // '.' // ctime(7:8)
         x_logtim(n_users)   = logtim(1:5)
         if (full) then
            x_image(n_users) = image(1:limage)
         else
            call parse (image(1:limage),' ','NAME', x_image(n_users))
         endif
      ENDIF
      if (n_users .lt. max_users) GO TO 10
C
C --- sort by user name, display, then hibernate
C
20    write(6,905) n_users
      call isort (x_user, n_users, ind)
      do 30 i = 1, n_users
         write (6, 920) x_user(i), x_terminal(ind(i)), x_cpu(ind(i)),
     $                  x_logtim(ind(i)), x_image(ind(i))
30    continue
      write(6,902) esc
      if (continuous) then
         CALL SYS$SCHDWK (,,ITIME,)
         CALL SYS$HIBER
         write(6,901) esc
         GO TO 5
      endif
      call exit
C
C                               
900   FORMAT(' ',A1,'[2J',A1,'[H')
901   FORMAT(' ',A1,'[H')
902   FORMAT(' ',A1,'[J')
905   format(' ','Number of users = ',i4,//,' ',
     $ 'User         Term         CPU  Login Image',/,1X,
     $ '----         ----         ---  ----- -----------------------')
910   FORMAT(I8)
920   format(' ',a12,' ',a7,' ',a9,' ',a5,' ',a40)
      END
C
C---END USERS
C
      SUBROUTINE CTLY
      CHARACTER *1 ESC
      DATA ESC/27/
C
      CALL LIB$ENABLE_CTRL('02100000'X,)
      WRITE(6,940) ESC, ESC
      CALL EXIT
940   FORMAT(' ',A1,'[2J',A1,'[H')
      END
C
C---END CTLY
C
